#!/usr/local/bin/ruby
# by YOSHIDA Kazuhiro (moriq.kazuhiro@nifty.ne.jp)

module RGUI
  class Frame < Widget
    include RGUI
    
    def initialize(gc, name='frame', width=80, height=80)
      super(gc)
      @name = name
      @width, @height = width, height
    end
    attr :name
    
    def layout
      exposed
      @childlen.each { |c|
        c.x = x + 16
        c.y = y + 16
        c.width  = width  - 32
        c.height = height - 32
        c.layout
      }
    end
    
    def exposed
      @gc.draw_frame self
    end
  end
end
