#!/usr/local/bin/ruby
# by YOSHIDA Kazuhiro (moriq.kazuhiro@nifty.ne.jp)

module RGUI
  class Widget
    def initialize(gc)
      @gc = gc
      @x, @y, @width, @height = 0, 0, 40, 20
      @focus = false
    end
    attr :focus,true
    attr :gc
    attr :x,true
    attr :y,true
    attr :width ,true
    attr :height,true
    
    def _button_press  (e=nil) button_press  (e) end
    def _button_release(e=nil) button_release(e) end
    def _key_press  (e=nil) key_press  (e) end
    def _key_release(e=nil) key_release(e) end
    def _motion_notify(e=nil) motion_notify(e) end
    def _exposed(e=nil) exposed(e) end
    
    def method_missing(m,*args)
      case m
      when :button_press, :button_release, :key_press, :key_release, :motion_notify, :exposed; return
      end
      raise NameError, "unknown method :#{m.id2name} for #{type}"
    end
    
    def gt(a,b); if a>b then a else b end; end
    def lt(a,b); if a<b then a else b end; end
    
  end
end
