#!/usr/local/bin/ruby
# by YOSHIDA Kazuhiro (moriq.kazuhiro@nifty.ne.jp)

class FrameGC < Xlib::GraphicContext
  def initialize(win)
    @fg_color = display.alloc_color 'black'
    @bg_color = display.alloc_color 'gray'
    @bright_color = display.alloc_color 'white'
    @shadow_color = display.alloc_color 'dim gray'
  end

  def draw_frame(a)
    # draw shadow
    self.fg = @shadow_color
    draw_rect a.x + 9, a.y + 9, a.width-16, a.height-16
    self.fg = @bg_color
    draw_line a.x + 9+11, a.y + 9, a.x + 9+13+a.name.length*RGUI::FontWidth, a.y + 9

    # draw high light
    self.fg = @bright_color
    draw_rect a.x + 8, a.y + 8, a.width-16, a.height-16
    self.fg = @bg_color
    draw_line a.x + 8+11, a.y + 8, a.x + 8+13+a.name.length*RGUI::FontWidth, a.y + 8

    # draw caption
    self.fg = @fg_color
    draw_str a.name, a.x + 9+12, a.y + 14
  end
end
